searchData={"items":[{"type":"module","title":"Giraffe","doc":"Documentation for `Giraffe`.","ref":"Giraffe.html"},{"type":"function","title":"Giraffe.hello/0","doc":"Hello world.","ref":"Giraffe.html#hello/0"},{"type":"function","title":"Examples - Giraffe.hello/0","doc":"iex> Giraffe.hello()\n    :world","ref":"Giraffe.html#hello/0-examples"},{"type":"module","title":"Giraffe.Algorithms.BellmanFord","doc":"Implementation of the Bellman-Ford algorithm for finding shortest paths in graphs.","ref":"Giraffe.Algorithms.BellmanFord.html"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.edge/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:edge/0"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.graph/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:graph/0"},{"type":"function","title":"Giraffe.Algorithms.BellmanFord.shortest_paths/2","doc":"Finds the shortest paths from a source vertex to all other vertices in the graph.\n\nReturns a map of vertices to their shortest distance from the source.\nIf a negative cycle is detected, returns `{:error, :negative_cycle}`.","ref":"Giraffe.Algorithms.BellmanFord.html#shortest_paths/2"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.vertex/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:vertex/0"},{"type":"module","title":"Giraffe.Algorithms.BronKerbosch","doc":"Implementation of the Bron-Kerbosch algorithm for finding maximal cliques in graphs.","ref":"Giraffe.Algorithms.BronKerbosch.html"},{"type":"function","title":"Giraffe.Algorithms.BronKerbosch.find_cliques/2","doc":"Finds all maximal cliques in a graph using the Bron-Kerbosch algorithm with pivot.","ref":"Giraffe.Algorithms.BronKerbosch.html#find_cliques/2"},{"type":"module","title":"Giraffe.Graph","doc":"Public interface for working with graphs. Delegates to specific implementations\nbased on whether the graph is directed or undirected.","ref":"Giraffe.Graph.html"},{"type":"function","title":"Giraffe.Graph.add_edge/4","doc":"","ref":"Giraffe.Graph.html#add_edge/4"},{"type":"function","title":"Giraffe.Graph.add_vertex/2","doc":"","ref":"Giraffe.Graph.html#add_vertex/2"},{"type":"type","title":"Giraffe.Graph.edge/0","doc":"","ref":"Giraffe.Graph.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.edges/1","doc":"","ref":"Giraffe.Graph.html#edges/1"},{"type":"function","title":"Giraffe.Graph.get_paths/3","doc":"","ref":"Giraffe.Graph.html#get_paths/3"},{"type":"function","title":"Giraffe.Graph.get_shortest_path/3","doc":"","ref":"Giraffe.Graph.html#get_shortest_path/3"},{"type":"function","title":"Giraffe.Graph.new/1","doc":"","ref":"Giraffe.Graph.html#new/1"},{"type":"type","title":"Giraffe.Graph.t/0","doc":"","ref":"Giraffe.Graph.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.vertex/0","doc":"","ref":"Giraffe.Graph.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.vertices/1","doc":"","ref":"Giraffe.Graph.html#vertices/1"},{"type":"type","title":"Giraffe.Graph.weight/0","doc":"","ref":"Giraffe.Graph.html#t:weight/0"},{"type":"module","title":"Giraffe.Graph.Directed","doc":"Implementation of a directed graph with weighted edges.\nVertices can be any term, and edges have numeric weights.","ref":"Giraffe.Graph.Directed.html"},{"type":"function","title":"Giraffe.Graph.Directed.add_edge/4","doc":"Adds a weighted edge between two vertices in the graph.\nThe vertices will be added to the graph if they don't already exist.","ref":"Giraffe.Graph.Directed.html#add_edge/4"},{"type":"function","title":"Giraffe.Graph.Directed.add_vertex/2","doc":"Adds a vertex to the graph.","ref":"Giraffe.Graph.Directed.html#add_vertex/2"},{"type":"function","title":"Giraffe.Graph.Directed.cliques/1","doc":"Finds all maximal cliques in the graph.\nA clique is a subset of vertices where every vertex is connected to every other vertex.\nOnly considers bidirectional edges.","ref":"Giraffe.Graph.Directed.html#cliques/1"},{"type":"type","title":"Giraffe.Graph.Directed.edge/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.Directed.edges/1","doc":"Returns a list of all edges in the graph as tuples of {from, to, weight}.","ref":"Giraffe.Graph.Directed.html#edges/1"},{"type":"function","title":"Giraffe.Graph.Directed.get_paths/3","doc":"Finds all possible paths between two vertices.\nReturns a list of tuples containing the path and its total weight.","ref":"Giraffe.Graph.Directed.html#get_paths/3"},{"type":"function","title":"Giraffe.Graph.Directed.get_shortest_path/3","doc":"Finds the shortest path between two vertices using Dijkstra's algorithm.\nReturns {:ok, path, total_weight} if a path exists, or :no_path if no path exists.","ref":"Giraffe.Graph.Directed.html#get_shortest_path/3"},{"type":"function","title":"Giraffe.Graph.Directed.is_acyclic?/1","doc":"Checks if the graph is acyclic.\n\nReturns `true` if the graph is acyclic, otherwise `false`.","ref":"Giraffe.Graph.Directed.html#is_acyclic?/1"},{"type":"function","title":"Giraffe.Graph.Directed.is_cyclic?/1","doc":"Checks if the graph is cyclic.\n\nReturns `true` if the graph contains cycles, otherwise `false`.","ref":"Giraffe.Graph.Directed.html#is_cyclic?/1"},{"type":"function","title":"Giraffe.Graph.Directed.neighbors/2","doc":"","ref":"Giraffe.Graph.Directed.html#neighbors/2"},{"type":"function","title":"Giraffe.Graph.Directed.new/0","doc":"Creates a new empty directed graph.","ref":"Giraffe.Graph.Directed.html#new/0"},{"type":"function","title":"Giraffe.Graph.Directed.postorder/1","doc":"","ref":"Giraffe.Graph.Directed.html#postorder/1"},{"type":"function","title":"Giraffe.Graph.Directed.shortest_paths/2","doc":"Finds the shortest paths from a source vertex to all other vertices using the Bellman-Ford algorithm.\nReturns {:ok, distances} with distances from source to all reachable vertices, or {:error, :negative_cycle}\nif a negative cycle is detected.","ref":"Giraffe.Graph.Directed.html#shortest_paths/2"},{"type":"type","title":"Giraffe.Graph.Directed.t/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.Directed.vertex/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.Directed.vertices/1","doc":"Returns a list of all vertices in the graph.","ref":"Giraffe.Graph.Directed.html#vertices/1"},{"type":"type","title":"Giraffe.Graph.Directed.weight/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:weight/0"},{"type":"module","title":"Giraffe.Graph.Undirected","doc":"Implementation of an undirected graph with weighted edges.\nVertices can be any term, and edges have numeric weights.","ref":"Giraffe.Graph.Undirected.html"},{"type":"function","title":"Giraffe.Graph.Undirected.add_edge/4","doc":"Adds an edge between two vertices with the given weight.\nIf the vertices don't exist, they will be added to the graph.","ref":"Giraffe.Graph.Undirected.html#add_edge/4"},{"type":"function","title":"Giraffe.Graph.Undirected.add_vertex/2","doc":"Adds a vertex to the graph.","ref":"Giraffe.Graph.Undirected.html#add_vertex/2"},{"type":"function","title":"Giraffe.Graph.Undirected.cliques/1","doc":"Detects all maximal cliques in the graph using the Bron-Kerbosch algorithm.\n\nReturns a list of cliques, where each clique is a list of vertices.\nA clique is a subset of vertices that forms a complete subgraph.","ref":"Giraffe.Graph.Undirected.html#cliques/1"},{"type":"type","title":"Giraffe.Graph.Undirected.edge/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.Undirected.edges/1","doc":"Returns a list of all edges in the graph.\nEach edge is represented as a tuple {from, to, weight}.","ref":"Giraffe.Graph.Undirected.html#edges/1"},{"type":"function","title":"Giraffe.Graph.Undirected.get_paths/3","doc":"Finds all possible paths between two vertices.\nReturns a list of tuples containing the path and its total weight.","ref":"Giraffe.Graph.Undirected.html#get_paths/3"},{"type":"function","title":"Giraffe.Graph.Undirected.get_shortest_path/3","doc":"Finds the shortest path between two vertices using Dijkstra's algorithm.\nReturns {:ok, path, total_weight} if a path exists, :no_path otherwise.","ref":"Giraffe.Graph.Undirected.html#get_shortest_path/3"},{"type":"function","title":"Giraffe.Graph.Undirected.is_acyclic?/1","doc":"Checks if the graph is acyclic (contains no cycles).\nReturns true if the graph has no cycles, false otherwise.","ref":"Giraffe.Graph.Undirected.html#is_acyclic?/1"},{"type":"function","title":"Giraffe.Graph.Undirected.is_cyclic?/1","doc":"Checks if the graph contains any cycles.\nReturns true if the graph has cycles, false otherwise.","ref":"Giraffe.Graph.Undirected.html#is_cyclic?/1"},{"type":"function","title":"Giraffe.Graph.Undirected.neighbors/2","doc":"","ref":"Giraffe.Graph.Undirected.html#neighbors/2"},{"type":"function","title":"Giraffe.Graph.Undirected.new/0","doc":"Creates a new empty undirected graph.","ref":"Giraffe.Graph.Undirected.html#new/0"},{"type":"function","title":"Giraffe.Graph.Undirected.postorder/1","doc":"","ref":"Giraffe.Graph.Undirected.html#postorder/1"},{"type":"function","title":"Giraffe.Graph.Undirected.shortest_paths/2","doc":"","ref":"Giraffe.Graph.Undirected.html#shortest_paths/2"},{"type":"type","title":"Giraffe.Graph.Undirected.t/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.Undirected.vertex/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.Undirected.vertices/1","doc":"Returns a list of all vertices in the graph.","ref":"Giraffe.Graph.Undirected.html#vertices/1"},{"type":"type","title":"Giraffe.Graph.Undirected.weight/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:weight/0"},{"type":"module","title":"Giraffe.PriorityQueue","doc":"A Priority Queue implementation using a list-based heap structure.\nLower priority values are dequeued first.","ref":"Giraffe.PriorityQueue.html"},{"type":"function","title":"Giraffe.PriorityQueue.dequeue/1","doc":"Dequeues the item with the lowest priority\nReturns {item, new_queue} or :empty if queue is empty","ref":"Giraffe.PriorityQueue.html#dequeue/1"},{"type":"function","title":"Giraffe.PriorityQueue.empty?/1","doc":"Checks if the queue is empty","ref":"Giraffe.PriorityQueue.html#empty?/1"},{"type":"function","title":"Giraffe.PriorityQueue.enqueue/3","doc":"Enqueues an item with a given priority","ref":"Giraffe.PriorityQueue.html#enqueue/3"},{"type":"function","title":"Giraffe.PriorityQueue.new/0","doc":"Creates a new empty priority queue","ref":"Giraffe.PriorityQueue.html#new/0"},{"type":"function","title":"Giraffe.PriorityQueue.peek/1","doc":"Returns the highest priority item without removing it from the queue\nReturns {:ok, item} or :empty if queue is empty","ref":"Giraffe.PriorityQueue.html#peek/1"},{"type":"function","title":"Giraffe.PriorityQueue.size/1","doc":"Returns the size of the queue","ref":"Giraffe.PriorityQueue.html#size/1"},{"type":"type","title":"Giraffe.PriorityQueue.t/0","doc":"","ref":"Giraffe.PriorityQueue.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}